package change

import "github.com/google/uuid"

// Change is an intended change to an OND. It is unique and immutable.
// It has a cuid, a timestamp, and holds both the previous and the new
// state. It keeps track if the state is committed and confirmed. A callback
// exists to acess the proper transport for the changed OND
type Change interface {
	ID() uuid.UUID
	Commit() error
	Confirm() error
}
